# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ftm_msgs/LCIRegistryUpdate.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ftm_msgs.msg
import genpy

class LCIRegistryUpdate(genpy.Message):
  _md5sum = "4dff1e45d73cdbf8395cd5a510a76fea"
  _type = "ftm_msgs/LCIRegistryUpdate"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """time stamp		# The timestamp of the recent change
string mac		# The mac of the device that has received update
LCIData lci_data
uint8 STATUS_ADDED = 0
uint8 STATUS_UPDATED = 1
uint8 STATUS_DELETED = 2
uint8 status

================================================================================
MSG: ftm_msgs/LCIData
string mac
string raw			# data is valid only if raw is not empty
float32 latitude
float32 latitude_uncertainty
float32 longitude
float32 longitude_uncertainty
uint8 ALTITUDE_TYPE_UNKNOWN = 0	# No Known Altitude
uint8 ALTITUDE_TYPE_METERS = 0	# Altitude in Meters
uint8 ALTITUDE_TYPE_FLOORS = 0	# Altitude in Floors
uint8 altitude_type
float32 altitude
float32 altitude_uncertainty
uint8 DATUM_WGS84 = 1
uint8 DATUM_NAD83_NAVD88 = 2
uint8 DATUM_NAD83_MLLW = 3
uint8 datum
bool reg_loc_agreement
bool reg_loc_dse
bool dependent_sta
uint8 version
bool has_floor_information        
uint8 expected_to_move
float32 sta_floor_number	# 512 indicates unknown floor number, 511.9375 indicates 511.9375 floors or more, -511.9375 indicates -511.9375 floors or less
float32 sta_height_above_floor	# 2048 indicates unknown height, 2047.9997... indicates 2047.999m or more, -2047.9997... indicates -2047.999m or less
float32 sta_height_above_floor_uncertainty	# 0 indicates unknown uncertainty, negative value is the negation of a reserved value (25 or higher)
"""
  # Pseudo-constants
  STATUS_ADDED = 0
  STATUS_UPDATED = 1
  STATUS_DELETED = 2

  __slots__ = ['stamp','mac','lci_data','status']
  _slot_types = ['time','string','ftm_msgs/LCIData','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       stamp,mac,lci_data,status

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(LCIRegistryUpdate, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.stamp is None:
        self.stamp = genpy.Time()
      if self.mac is None:
        self.mac = ''
      if self.lci_data is None:
        self.lci_data = ftm_msgs.msg.LCIData()
      if self.status is None:
        self.status = 0
    else:
      self.stamp = genpy.Time()
      self.mac = ''
      self.lci_data = ftm_msgs.msg.LCIData()
      self.status = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2I().pack(_x.stamp.secs, _x.stamp.nsecs))
      _x = self.mac
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.lci_data.mac
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.lci_data.raw
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_4fB2f7B3fB().pack(_x.lci_data.latitude, _x.lci_data.latitude_uncertainty, _x.lci_data.longitude, _x.lci_data.longitude_uncertainty, _x.lci_data.altitude_type, _x.lci_data.altitude, _x.lci_data.altitude_uncertainty, _x.lci_data.datum, _x.lci_data.reg_loc_agreement, _x.lci_data.reg_loc_dse, _x.lci_data.dependent_sta, _x.lci_data.version, _x.lci_data.has_floor_information, _x.lci_data.expected_to_move, _x.lci_data.sta_floor_number, _x.lci_data.sta_height_above_floor, _x.lci_data.sta_height_above_floor_uncertainty, _x.status))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.stamp is None:
        self.stamp = genpy.Time()
      if self.lci_data is None:
        self.lci_data = ftm_msgs.msg.LCIData()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.stamp.secs, _x.stamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.mac = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.mac = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.lci_data.mac = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.lci_data.mac = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.lci_data.raw = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.lci_data.raw = str[start:end]
      _x = self
      start = end
      end += 45
      (_x.lci_data.latitude, _x.lci_data.latitude_uncertainty, _x.lci_data.longitude, _x.lci_data.longitude_uncertainty, _x.lci_data.altitude_type, _x.lci_data.altitude, _x.lci_data.altitude_uncertainty, _x.lci_data.datum, _x.lci_data.reg_loc_agreement, _x.lci_data.reg_loc_dse, _x.lci_data.dependent_sta, _x.lci_data.version, _x.lci_data.has_floor_information, _x.lci_data.expected_to_move, _x.lci_data.sta_floor_number, _x.lci_data.sta_height_above_floor, _x.lci_data.sta_height_above_floor_uncertainty, _x.status,) = _get_struct_4fB2f7B3fB().unpack(str[start:end])
      self.lci_data.reg_loc_agreement = bool(self.lci_data.reg_loc_agreement)
      self.lci_data.reg_loc_dse = bool(self.lci_data.reg_loc_dse)
      self.lci_data.dependent_sta = bool(self.lci_data.dependent_sta)
      self.lci_data.has_floor_information = bool(self.lci_data.has_floor_information)
      self.stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2I().pack(_x.stamp.secs, _x.stamp.nsecs))
      _x = self.mac
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.lci_data.mac
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.lci_data.raw
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_4fB2f7B3fB().pack(_x.lci_data.latitude, _x.lci_data.latitude_uncertainty, _x.lci_data.longitude, _x.lci_data.longitude_uncertainty, _x.lci_data.altitude_type, _x.lci_data.altitude, _x.lci_data.altitude_uncertainty, _x.lci_data.datum, _x.lci_data.reg_loc_agreement, _x.lci_data.reg_loc_dse, _x.lci_data.dependent_sta, _x.lci_data.version, _x.lci_data.has_floor_information, _x.lci_data.expected_to_move, _x.lci_data.sta_floor_number, _x.lci_data.sta_height_above_floor, _x.lci_data.sta_height_above_floor_uncertainty, _x.status))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.stamp is None:
        self.stamp = genpy.Time()
      if self.lci_data is None:
        self.lci_data = ftm_msgs.msg.LCIData()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.stamp.secs, _x.stamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.mac = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.mac = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.lci_data.mac = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.lci_data.mac = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.lci_data.raw = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.lci_data.raw = str[start:end]
      _x = self
      start = end
      end += 45
      (_x.lci_data.latitude, _x.lci_data.latitude_uncertainty, _x.lci_data.longitude, _x.lci_data.longitude_uncertainty, _x.lci_data.altitude_type, _x.lci_data.altitude, _x.lci_data.altitude_uncertainty, _x.lci_data.datum, _x.lci_data.reg_loc_agreement, _x.lci_data.reg_loc_dse, _x.lci_data.dependent_sta, _x.lci_data.version, _x.lci_data.has_floor_information, _x.lci_data.expected_to_move, _x.lci_data.sta_floor_number, _x.lci_data.sta_height_above_floor, _x.lci_data.sta_height_above_floor_uncertainty, _x.status,) = _get_struct_4fB2f7B3fB().unpack(str[start:end])
      self.lci_data.reg_loc_agreement = bool(self.lci_data.reg_loc_agreement)
      self.lci_data.reg_loc_dse = bool(self.lci_data.reg_loc_dse)
      self.lci_data.dependent_sta = bool(self.lci_data.dependent_sta)
      self.lci_data.has_floor_information = bool(self.lci_data.has_floor_information)
      self.stamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_4fB2f7B3fB = None
def _get_struct_4fB2f7B3fB():
    global _struct_4fB2f7B3fB
    if _struct_4fB2f7B3fB is None:
        _struct_4fB2f7B3fB = struct.Struct("<4fB2f7B3fB")
    return _struct_4fB2f7B3fB
