# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ftm_msgs/AddLCIRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ftm_msgs.msg

class AddLCIRequest(genpy.Message):
  _md5sum = "47fdd5c279be4510f6c35d10e5083614"
  _type = "ftm_msgs/AddLCIRequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """
LCIData[] lci_data_list

================================================================================
MSG: ftm_msgs/LCIData
string mac
string raw			# data is valid only if raw is not empty
float32 latitude
float32 latitude_uncertainty
float32 longitude
float32 longitude_uncertainty
uint8 ALTITUDE_TYPE_UNKNOWN = 0	# No Known Altitude
uint8 ALTITUDE_TYPE_METERS = 0	# Altitude in Meters
uint8 ALTITUDE_TYPE_FLOORS = 0	# Altitude in Floors
uint8 altitude_type
float32 altitude
float32 altitude_uncertainty
uint8 DATUM_WGS84 = 1
uint8 DATUM_NAD83_NAVD88 = 2
uint8 DATUM_NAD83_MLLW = 3
uint8 datum
bool reg_loc_agreement
bool reg_loc_dse
bool dependent_sta
uint8 version
bool has_floor_information        
uint8 expected_to_move
float32 sta_floor_number	# 512 indicates unknown floor number, 511.9375 indicates 511.9375 floors or more, -511.9375 indicates -511.9375 floors or less
float32 sta_height_above_floor	# 2048 indicates unknown height, 2047.9997... indicates 2047.999m or more, -2047.9997... indicates -2047.999m or less
float32 sta_height_above_floor_uncertainty	# 0 indicates unknown uncertainty, negative value is the negation of a reserved value (25 or higher)
"""
  __slots__ = ['lci_data_list']
  _slot_types = ['ftm_msgs/LCIData[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       lci_data_list

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(AddLCIRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.lci_data_list is None:
        self.lci_data_list = []
    else:
      self.lci_data_list = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.lci_data_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.lci_data_list:
        _x = val1.mac
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.raw
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_4fB2f7B3f().pack(_x.latitude, _x.latitude_uncertainty, _x.longitude, _x.longitude_uncertainty, _x.altitude_type, _x.altitude, _x.altitude_uncertainty, _x.datum, _x.reg_loc_agreement, _x.reg_loc_dse, _x.dependent_sta, _x.version, _x.has_floor_information, _x.expected_to_move, _x.sta_floor_number, _x.sta_height_above_floor, _x.sta_height_above_floor_uncertainty))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.lci_data_list is None:
        self.lci_data_list = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.lci_data_list = []
      for i in range(0, length):
        val1 = ftm_msgs.msg.LCIData()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.mac = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.mac = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.raw = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.raw = str[start:end]
        _x = val1
        start = end
        end += 44
        (_x.latitude, _x.latitude_uncertainty, _x.longitude, _x.longitude_uncertainty, _x.altitude_type, _x.altitude, _x.altitude_uncertainty, _x.datum, _x.reg_loc_agreement, _x.reg_loc_dse, _x.dependent_sta, _x.version, _x.has_floor_information, _x.expected_to_move, _x.sta_floor_number, _x.sta_height_above_floor, _x.sta_height_above_floor_uncertainty,) = _get_struct_4fB2f7B3f().unpack(str[start:end])
        val1.reg_loc_agreement = bool(val1.reg_loc_agreement)
        val1.reg_loc_dse = bool(val1.reg_loc_dse)
        val1.dependent_sta = bool(val1.dependent_sta)
        val1.has_floor_information = bool(val1.has_floor_information)
        self.lci_data_list.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.lci_data_list)
      buff.write(_struct_I.pack(length))
      for val1 in self.lci_data_list:
        _x = val1.mac
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.raw
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_4fB2f7B3f().pack(_x.latitude, _x.latitude_uncertainty, _x.longitude, _x.longitude_uncertainty, _x.altitude_type, _x.altitude, _x.altitude_uncertainty, _x.datum, _x.reg_loc_agreement, _x.reg_loc_dse, _x.dependent_sta, _x.version, _x.has_floor_information, _x.expected_to_move, _x.sta_floor_number, _x.sta_height_above_floor, _x.sta_height_above_floor_uncertainty))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.lci_data_list is None:
        self.lci_data_list = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.lci_data_list = []
      for i in range(0, length):
        val1 = ftm_msgs.msg.LCIData()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.mac = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.mac = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.raw = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.raw = str[start:end]
        _x = val1
        start = end
        end += 44
        (_x.latitude, _x.latitude_uncertainty, _x.longitude, _x.longitude_uncertainty, _x.altitude_type, _x.altitude, _x.altitude_uncertainty, _x.datum, _x.reg_loc_agreement, _x.reg_loc_dse, _x.dependent_sta, _x.version, _x.has_floor_information, _x.expected_to_move, _x.sta_floor_number, _x.sta_height_above_floor, _x.sta_height_above_floor_uncertainty,) = _get_struct_4fB2f7B3f().unpack(str[start:end])
        val1.reg_loc_agreement = bool(val1.reg_loc_agreement)
        val1.reg_loc_dse = bool(val1.reg_loc_dse)
        val1.dependent_sta = bool(val1.dependent_sta)
        val1.has_floor_information = bool(val1.has_floor_information)
        self.lci_data_list.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_4fB2f7B3f = None
def _get_struct_4fB2f7B3f():
    global _struct_4fB2f7B3f
    if _struct_4fB2f7B3f is None:
        _struct_4fB2f7B3f = struct.Struct("<4fB2f7B3f")
    return _struct_4fB2f7B3f
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from ftm_msgs/AddLCIResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class AddLCIResponse(genpy.Message):
  _md5sum = "284aa12dd9e9e760802ac9f38036ea5e"
  _type = "ftm_msgs/AddLCIResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """uint8 status

"""
  __slots__ = ['status']
  _slot_types = ['uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       status

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(AddLCIResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.status is None:
        self.status = 0
    else:
      self.status = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.status
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.status,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.status
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.status,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
class AddLCI(object):
  _type          = 'ftm_msgs/AddLCI'
  _md5sum = 'fb36b37a997ff658a5f9c6ddd624baf5'
  _request_class  = AddLCIRequest
  _response_class = AddLCIResponse
